Package ghidra.debug.flatapi

# Interface FlatDebuggerRmiAPI

All Superinterfaces:
  `FlatDebuggerAPI`

public interface FlatDebuggerRmiAPI extends FlatDebuggerAPI

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface ghidra.debug.flatapi.FlatDebuggerAPI

  `FlatDebuggerAPI.ExpectingBreakpointChanges`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default Collection<TraceRmiLaunchOffer>`
  `getLaunchOffers()`
  Get offers for launching the current program
  `default Collection<TraceRmiLaunchOffer>`
  `getLaunchOffers(Program program)`
  Get offers for launching the given program
  `default List<TraceRmiLaunchOffer>`
  `getSavedLaunchOffers()`
  Get saved offers for launching the current program, ordered by most-recently-saved
  `default List<TraceRmiLaunchOffer>`
  `getSavedLaunchOffers(Program program)`
  Get saved offers for launching the given program, ordered by most-recently-saved
  `default TraceRmiLauncherService`
  `getTraceRmiLauncherService()`
  Get the trace-rmi launcher service
  `default TraceRmiLaunchOffer.LaunchResult`
  `launch(TraceRmiLaunchOffer offer, TaskMonitor monitor)`
  Launch the given offer with the default or saved arguments
  `default TraceRmiLaunchOffer.LaunchResult`
  `launch(TraceRmiLaunchOffer offer, Map<String,?> overrideArgs, TaskMonitor monitor)`
  Launch the given offer with the default, saved, and/or overridden arguments
  `default TraceRmiLaunchOffer.LaunchResult`
  `launch(Program program, TaskMonitor monitor)`
  Launch the given program with the most-recently-saved offer
  `default TraceRmiLaunchOffer.LaunchResult`
  `launch(TaskMonitor monitor)`
  Launch the current program with the most-recently-saved offer
  `default TraceRmiLaunchOffer`
  `requireLastLaunchOffer()`
  Get the most-recently-saved launch offer for the current program
  `default TraceRmiLaunchOffer`
  `requireLastLaunchOffer(Program program)`
  Get the most-recently-saved launch offer for the given program

  ### Methods inherited from interface ghidra.debug.flatapi.FlatDebuggerAPI

  `activateFrame, activateSnap, activateThread, activateTrace, breakpointsClear, breakpointsDisable, breakpointsEnable, breakpointSet, breakpointSetAccess, breakpointSetHardwareExecute, breakpointSetRead, breakpointSetSoftwareExecute, breakpointSetWrite, breakpointsToggle, closeTrace, createContext, createContext, createContext, createStateEditor, createStateEditor, createStateEditor, createStateEditor, doAction, doThreadAction, doTraceAction, dynamicLocation, dynamicLocation, dynamicLocation, dynamicLocation, dynamicLocation, dynamicLocation, dynamicLocation, dynamicLocation, emulate, emulate, emulate, emulateLaunch, emulateLaunch, evaluate, evaluate, execute, execute, executeCapture, executeCapture, expectBreakpointChanges, findAction, flushAsyncPipelines, getAllBreakpoints, getBreakpoints, getBreakpoints, getBreakpointsAt, getBreakpointService, getBreakpointsNamed, getControlService, getCurrentDebuggerAddress, getCurrentDebuggerCoordinates, getCurrentDebuggerProgramLocation, getCurrentEmulationSchedule, getCurrentFrame, getCurrentPlatform, getCurrentProgram, getCurrentSnap, getCurrentThread, getCurrentTrace, getCurrentView, getDebuggerListing, getEmulationService, getExecutionState, getExecutionState, getMappingService, getProgramCounter, getProgramCounter, getStackPointer, getStackPointer, getState, getTargetService, getTrace, getTraceManager, goToDynamic, goToDynamic, goToDynamic, interrupt, interrupt, interrupt, isTargetAlive, isTargetAlive, isThreadAlive, isThreadAlive, kill, kill, kill, openTrace, patchEmu, readMemory, readMemory, readMemory, readMemory, readRegister, readRegister, readRegister, readRegister, readRegisters, readRegisters, readRegistersNamed, refreshMemoryIfLive, refreshRegistersIfLive, requireCurrentPlatform, requireCurrentProgram, requireCurrentThread, requireCurrentTrace, requireCurrentView, requirePlatform, requireService, requireThread, requireTrace, resume, resume, resume, safeRange, searchMemory, searchMemory, setControlMode, setControlMode, skipEmuInstruction, skipEmuPcodeOp, staticLocation, staticLocation, staticLocation, staticLocation, stepEmuInstruction, stepEmuPcodeOp, stepInto, stepInto, stepOut, stepOut, stepOver, stepOver, translateDynamicToStatic, translateDynamicToStatic, translateStaticToDynamic, translateStaticToDynamic, validateRegisterName, validateRegisterNames, waitForBreak, waitForBreak, waitOn, writeMemory, writeMemory, writeMemory, writeRegister, writeRegister, writeRegister, writeRegister, writeRegister`

- ## Method Details

  - ### getTraceRmiLauncherService

    default TraceRmiLauncherService getTraceRmiLauncherService()
    Get the trace-rmi launcher service
    Returns:
      the service

  - ### getLaunchOffers

    default Collection<TraceRmiLaunchOffer> getLaunchOffers(Program program)
    Get offers for launching the given program
    Parameters:
      `program` - the program, or null for no image
    Returns:
      the offers

  - ### getLaunchOffers

    default Collection<TraceRmiLaunchOffer> getLaunchOffers()
    Get offers for launching the current program
    Returns:
      the offers

  - ### getSavedLaunchOffers

    default List<TraceRmiLaunchOffer> getSavedLaunchOffers(Program program)
    Get saved offers for launching the given program, ordered by most-recently-saved
    Parameters:
      `program` - the program, or null for no image
    Returns:
      the offers

  - ### getSavedLaunchOffers

    default List<TraceRmiLaunchOffer> getSavedLaunchOffers()
    Get saved offers for launching the current program, ordered by most-recently-saved
    Returns:
      the offers

  - ### requireLastLaunchOffer

    default TraceRmiLaunchOffer requireLastLaunchOffer(Program program)
    Get the most-recently-saved launch offer for the given program
    Parameters:
      `program` - the program, or null for no image
    Returns:
      the offer
    Throws:
      `NoSuchElementException` - if no offer's configuration has been saved

  - ### requireLastLaunchOffer

    default TraceRmiLaunchOffer requireLastLaunchOffer()
    Get the most-recently-saved launch offer for the current program
    Returns:
      the offer
    Throws:
      `NoSuchElementException` - if no offer's configuration has been saved

  - ### launch

    default TraceRmiLaunchOffer.LaunchResult launch(TraceRmiLaunchOffer offer, Map<String,?> overrideArgs, TaskMonitor monitor)
    Launch the given offer with the default, saved, and/or overridden arguments

    If the offer has saved arguments, those will be loaded. Otherwise, the default arguments will be used. If given, specific arguments can be overridden by the caller. The caller may need to examine the offer's parameters before overriding any arguments. Conventionally, the argument displayed as "Image" gives the path to the executable, and "Args" gives the command-line arguments to pass to the target.

    Parameters:
      `offer` - the offer to launch
      `overrideArgs` - overridden arguments, which may be empty
      `monitor` - a monitor for the launch stages
    Returns:
      the launch result, which may indicate errors

  - ### launch

    default TraceRmiLaunchOffer.LaunchResult launch(TraceRmiLaunchOffer offer, TaskMonitor monitor)
    Launch the given offer with the default or saved arguments
    Parameters:
      `offer` - the offer to launch
      `monitor` - a monitor for the launch stages
    Returns:
      the launch result, which may indicate errors

  - ### launch

    default TraceRmiLaunchOffer.LaunchResult launch(Program program, TaskMonitor monitor)
    Launch the given program with the most-recently-saved offer
    Parameters:
      `program` - the program to launch
      `monitor` - a monitor for the launch stages
    Returns:
      the launch result, which may indicate errors

  - ### launch

    default TraceRmiLaunchOffer.LaunchResult launch(TaskMonitor monitor)
    Launch the current program with the most-recently-saved offer
    Parameters:
      `monitor` - a monitor for the launch stages
    Returns:
      the launch result, which may indicate errors